/*
 * This file is generated by gdbus-codegen, do not modify it.
 *
 * The license of this code is the same as for the D-Bus interface description
 * it was derived from. Note that it links to GLib, so must comply with the
 * LGPL linking clauses.
 */

#ifndef __NOTIFICATIONS_DBUS_H__
#define __NOTIFICATIONS_DBUS_H__

#include <gio/gio.h>

G_BEGIN_DECLS


/* ------------------------------------------------------------------------ */
/* Declarations for org.freedesktop.Notifications */

#define DBUS_TYPE_NOTIFICATIONS (dbus_notifications_get_type ())
#define DBUS_NOTIFICATIONS(o) (G_TYPE_CHECK_INSTANCE_CAST ((o), DBUS_TYPE_NOTIFICATIONS, DbusNotifications))
#define DBUS_IS_NOTIFICATIONS(o) (G_TYPE_CHECK_INSTANCE_TYPE ((o), DBUS_TYPE_NOTIFICATIONS))
#define DBUS_NOTIFICATIONS_GET_IFACE(o) (G_TYPE_INSTANCE_GET_INTERFACE ((o), DBUS_TYPE_NOTIFICATIONS, DbusNotificationsIface))

struct _DbusNotifications;
typedef struct _DbusNotifications DbusNotifications;
typedef struct _DbusNotificationsIface DbusNotificationsIface;

struct _DbusNotificationsIface
{
  GTypeInterface parent_iface;


  gboolean (*handle_close_notification) (
    DbusNotifications *object,
    GDBusMethodInvocation *invocation,
    guint arg_id);

  gboolean (*handle_get_capabilities) (
    DbusNotifications *object,
    GDBusMethodInvocation *invocation);

  gboolean (*handle_get_server_information) (
    DbusNotifications *object,
    GDBusMethodInvocation *invocation);

  gboolean (*handle_notify) (
    DbusNotifications *object,
    GDBusMethodInvocation *invocation,
    const gchar *arg_app_name,
    guint arg_replaces_id,
    const gchar *arg_app_icon,
    const gchar *arg_summary,
    const gchar *arg_body,
    const gchar *const *arg_actions,
    GVariant *arg_hints,
    gint arg_timeout);

  void (*action_invoked) (
    DbusNotifications *object,
    guint arg_id,
    const gchar *arg_action_key);

  void (*notification_closed) (
    DbusNotifications *object,
    guint arg_id,
    guint arg_reason);

};

GType dbus_notifications_get_type (void) G_GNUC_CONST;

GDBusInterfaceInfo *dbus_notifications_interface_info (void);
guint dbus_notifications_override_properties (GObjectClass *klass, guint property_id_begin);


/* D-Bus method call completion functions: */
void dbus_notifications_complete_notify (
    DbusNotifications *object,
    GDBusMethodInvocation *invocation,
    guint unnamed_arg8);

void dbus_notifications_complete_close_notification (
    DbusNotifications *object,
    GDBusMethodInvocation *invocation);

void dbus_notifications_complete_get_capabilities (
    DbusNotifications *object,
    GDBusMethodInvocation *invocation,
    const gchar *const *caps);

void dbus_notifications_complete_get_server_information (
    DbusNotifications *object,
    GDBusMethodInvocation *invocation,
    const gchar *name,
    const gchar *vendor,
    const gchar *version,
    const gchar *spec_version);



/* D-Bus signal emissions functions: */
void dbus_notifications_emit_notification_closed (
    DbusNotifications *object,
    guint arg_id,
    guint arg_reason);

void dbus_notifications_emit_action_invoked (
    DbusNotifications *object,
    guint arg_id,
    const gchar *arg_action_key);



/* D-Bus method calls: */
void dbus_notifications_call_notify (
    DbusNotifications *proxy,
    const gchar *arg_app_name,
    guint arg_replaces_id,
    const gchar *arg_app_icon,
    const gchar *arg_summary,
    const gchar *arg_body,
    const gchar *const *arg_actions,
    GVariant *arg_hints,
    gint arg_timeout,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean dbus_notifications_call_notify_finish (
    DbusNotifications *proxy,
    guint *out_unnamed_arg8,
    GAsyncResult *res,
    GError **error);

gboolean dbus_notifications_call_notify_sync (
    DbusNotifications *proxy,
    const gchar *arg_app_name,
    guint arg_replaces_id,
    const gchar *arg_app_icon,
    const gchar *arg_summary,
    const gchar *arg_body,
    const gchar *const *arg_actions,
    GVariant *arg_hints,
    gint arg_timeout,
    guint *out_unnamed_arg8,
    GCancellable *cancellable,
    GError **error);

void dbus_notifications_call_close_notification (
    DbusNotifications *proxy,
    guint arg_id,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean dbus_notifications_call_close_notification_finish (
    DbusNotifications *proxy,
    GAsyncResult *res,
    GError **error);

gboolean dbus_notifications_call_close_notification_sync (
    DbusNotifications *proxy,
    guint arg_id,
    GCancellable *cancellable,
    GError **error);

void dbus_notifications_call_get_capabilities (
    DbusNotifications *proxy,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean dbus_notifications_call_get_capabilities_finish (
    DbusNotifications *proxy,
    gchar ***out_caps,
    GAsyncResult *res,
    GError **error);

gboolean dbus_notifications_call_get_capabilities_sync (
    DbusNotifications *proxy,
    gchar ***out_caps,
    GCancellable *cancellable,
    GError **error);

void dbus_notifications_call_get_server_information (
    DbusNotifications *proxy,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean dbus_notifications_call_get_server_information_finish (
    DbusNotifications *proxy,
    gchar **out_name,
    gchar **out_vendor,
    gchar **out_version,
    gchar **out_spec_version,
    GAsyncResult *res,
    GError **error);

gboolean dbus_notifications_call_get_server_information_sync (
    DbusNotifications *proxy,
    gchar **out_name,
    gchar **out_vendor,
    gchar **out_version,
    gchar **out_spec_version,
    GCancellable *cancellable,
    GError **error);



/* ---- */

#define DBUS_TYPE_NOTIFICATIONS_PROXY (dbus_notifications_proxy_get_type ())
#define DBUS_NOTIFICATIONS_PROXY(o) (G_TYPE_CHECK_INSTANCE_CAST ((o), DBUS_TYPE_NOTIFICATIONS_PROXY, DbusNotificationsProxy))
#define DBUS_NOTIFICATIONS_PROXY_CLASS(k) (G_TYPE_CHECK_CLASS_CAST ((k), DBUS_TYPE_NOTIFICATIONS_PROXY, DbusNotificationsProxyClass))
#define DBUS_NOTIFICATIONS_PROXY_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), DBUS_TYPE_NOTIFICATIONS_PROXY, DbusNotificationsProxyClass))
#define DBUS_IS_NOTIFICATIONS_PROXY(o) (G_TYPE_CHECK_INSTANCE_TYPE ((o), DBUS_TYPE_NOTIFICATIONS_PROXY))
#define DBUS_IS_NOTIFICATIONS_PROXY_CLASS(k) (G_TYPE_CHECK_CLASS_TYPE ((k), DBUS_TYPE_NOTIFICATIONS_PROXY))

typedef struct _DbusNotificationsProxy DbusNotificationsProxy;
typedef struct _DbusNotificationsProxyClass DbusNotificationsProxyClass;
typedef struct _DbusNotificationsProxyPrivate DbusNotificationsProxyPrivate;

struct _DbusNotificationsProxy
{
  /*< private >*/
  GDBusProxy parent_instance;
  DbusNotificationsProxyPrivate *priv;
};

struct _DbusNotificationsProxyClass
{
  GDBusProxyClass parent_class;
};

GType dbus_notifications_proxy_get_type (void) G_GNUC_CONST;

#if GLIB_CHECK_VERSION(2, 44, 0)
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DbusNotificationsProxy, g_object_unref)
#endif

void dbus_notifications_proxy_new (
    GDBusConnection     *connection,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GAsyncReadyCallback  callback,
    gpointer             user_data);
DbusNotifications *dbus_notifications_proxy_new_finish (
    GAsyncResult        *res,
    GError             **error);
DbusNotifications *dbus_notifications_proxy_new_sync (
    GDBusConnection     *connection,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GError             **error);

void dbus_notifications_proxy_new_for_bus (
    GBusType             bus_type,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GAsyncReadyCallback  callback,
    gpointer             user_data);
DbusNotifications *dbus_notifications_proxy_new_for_bus_finish (
    GAsyncResult        *res,
    GError             **error);
DbusNotifications *dbus_notifications_proxy_new_for_bus_sync (
    GBusType             bus_type,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GError             **error);


/* ---- */

#define DBUS_TYPE_NOTIFICATIONS_SKELETON (dbus_notifications_skeleton_get_type ())
#define DBUS_NOTIFICATIONS_SKELETON(o) (G_TYPE_CHECK_INSTANCE_CAST ((o), DBUS_TYPE_NOTIFICATIONS_SKELETON, DbusNotificationsSkeleton))
#define DBUS_NOTIFICATIONS_SKELETON_CLASS(k) (G_TYPE_CHECK_CLASS_CAST ((k), DBUS_TYPE_NOTIFICATIONS_SKELETON, DbusNotificationsSkeletonClass))
#define DBUS_NOTIFICATIONS_SKELETON_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), DBUS_TYPE_NOTIFICATIONS_SKELETON, DbusNotificationsSkeletonClass))
#define DBUS_IS_NOTIFICATIONS_SKELETON(o) (G_TYPE_CHECK_INSTANCE_TYPE ((o), DBUS_TYPE_NOTIFICATIONS_SKELETON))
#define DBUS_IS_NOTIFICATIONS_SKELETON_CLASS(k) (G_TYPE_CHECK_CLASS_TYPE ((k), DBUS_TYPE_NOTIFICATIONS_SKELETON))

typedef struct _DbusNotificationsSkeleton DbusNotificationsSkeleton;
typedef struct _DbusNotificationsSkeletonClass DbusNotificationsSkeletonClass;
typedef struct _DbusNotificationsSkeletonPrivate DbusNotificationsSkeletonPrivate;

struct _DbusNotificationsSkeleton
{
  /*< private >*/
  GDBusInterfaceSkeleton parent_instance;
  DbusNotificationsSkeletonPrivate *priv;
};

struct _DbusNotificationsSkeletonClass
{
  GDBusInterfaceSkeletonClass parent_class;
};

GType dbus_notifications_skeleton_get_type (void) G_GNUC_CONST;

#if GLIB_CHECK_VERSION(2, 44, 0)
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DbusNotificationsSkeleton, g_object_unref)
#endif

DbusNotifications *dbus_notifications_skeleton_new (void);


G_END_DECLS

#endif /* __NOTIFICATIONS_DBUS_H__ */
